<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SymbolFactory.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SymbolFactory.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SymbolFactory.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_SymbolFactory_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_SymbolFactory_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/SymbolLookup/Scope.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;stack&gt;</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line14"></a><span class="lineno">14</span><span class="line">{</span>
<a id="line15"></a><span class="lineno">15</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis/SymbolLookup.html" title="namespace Synopsis::SymbolLookup">SymbolLookup</a></span>
<a id="line16"></a><span class="lineno">16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">class PrototypeScope;</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">class TemplateParameterScope;</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">}</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="comment">//. SymbolFactory populates a symbol table.</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="keyword">class</span> <a href="../../Scopes/Synopsis/SymbolFactory.html" title="class Synopsis::SymbolFactory">SymbolFactory</a></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  <span class="comment">//.</span></span>
<a id="line26"></a><span class="lineno">26</span><span class="line">  <span class="keyword">enum</span> <a href="../../Scopes/Synopsis/SymbolFactory.html#Language" title="enum Synopsis::SymbolFactory::Language">Language</a> { <a href="../../Scopes/Synopsis/SymbolFactory.html#NONE" title="enumerator Synopsis::SymbolFactory::NONE">NONE</a> = 0x00, <a href="../../Scopes/Synopsis/SymbolFactory.html#C99" title="enumerator Synopsis::SymbolFactory::C99">C99</a> = 0x01, <a href="../../Scopes/Synopsis/SymbolFactory.html#CXX" title="enumerator Synopsis::SymbolFactory::CXX">CXX</a> = 0x02};</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">  <span class="comment">//. Create a symbol lookup table for the given language.</span></span>
<a id="line29"></a><span class="lineno">29</span><span class="line"><span class="comment">  //. Right now only CXX is supported.</span></span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolFactory.html#SymbolFactory_lLanguage_r" title="member function Synopsis::SymbolFactory::SymbolFactory(Language)">SymbolFactory</a>(<a href="../../Scopes/Synopsis/SymbolFactory.html#Language" title="enum Synopsis::SymbolFactory::Language">Language</a> = CXX);</span>
<a id="line31"></a><span class="lineno">31</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope</a> *<a href="../../Scopes/Synopsis/SymbolFactory.html#current_scope_l_r" title="member function Synopsis::SymbolFactory::current_scope()">current_scope</a>() { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/SymbolFactory.html#my_scopes" title="data member Synopsis::SymbolFactory::my_scopes">my_scopes</a>.<a href="" title="member function std::stack::top()">top</a>();}</span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::NamespaceSpec*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec const</a> *);</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::ClassSpec*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec const</a> *);</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::Node*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *);</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::FunctionDefinition*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/FunctionDefinition.html" title="class Synopsis::PTree::FunctionDefinition">PTree::FunctionDefinition const</a> *);</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::TemplateDecl*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">PTree::TemplateDecl const</a> *);</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::enter_scope(const PTree::Block*)">enter_scope</a>(<a href="../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">PTree::Block const</a> *);</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/SymbolFactory.html#leave_scope_l_r" title="member function Synopsis::SymbolFactory::leave_scope()">leave_scope</a>();</span>
<a id="line41"></a><span class="lineno">41</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::Declaration*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration const</a> *);</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::Typedef*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/Typedef.html" title="class Synopsis::PTree::Typedef">PTree::Typedef const</a> *);</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">  <span class="comment">//. declare the enumeration as a new TYPE as well as all the enumerators as CONST</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::EnumSpec*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/EnumSpec.html" title="class Synopsis::PTree::EnumSpec">PTree::EnumSpec const</a> *);</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">  <span class="comment">//. declare the namespace as a new NAMESPACE</span></span>
<a id="line47"></a><span class="lineno">47</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::NamespaceSpec*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec const</a> *);</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">  <span class="comment">//. declare the class as a new TYPE</span></span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::ClassSpec*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec const</a> *);</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::TemplateDecl*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">PTree::TemplateDecl const</a> *);</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::TypeParameter*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/TypeParameter.html" title="class Synopsis::PTree::TypeParameter">PTree::TypeParameter const</a> *);</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::UsingDirective*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">PTree::UsingDirective const</a> *);</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::ParameterDeclaration*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/ParameterDeclaration.html" title="class Synopsis::PTree::ParameterDeclaration">PTree::ParameterDeclaration const</a> *);</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolFactory::declare(const PTree::UsingDeclaration*)">declare</a>(<a href="../../Scopes/Synopsis/PTree/UsingDeclaration.html" title="class Synopsis::PTree::UsingDeclaration">PTree::UsingDeclaration const</a> *);</span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::stack">stack</a>&lt;<a href="../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope</a> *&gt; <a href="../../Scopes/Synopsis/SymbolFactory.html#Scopes" title="typedef Synopsis::SymbolFactory::Scopes">Scopes</a>;</span>
<a id="line58"></a><span class="lineno">58</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">  <span class="comment">//. Lookup the scope of a qualified name.</span></span>
<a id="line60"></a><span class="lineno">60</span><span class="line"><span class="comment">  //. The encoded name is modified in place to</span></span>
<a id="line61"></a><span class="lineno">61</span><span class="line"><span class="comment">  //. refer to the unqualified name.</span></span>
<a id="line62"></a><span class="lineno">62</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope</a> *<a href="" title="member function Synopsis::SymbolFactory::lookup_scope_of_qname(PTree::Encoding&amp;,const PTree::Node*)">lookup_scope_of_qname</a>(<a href="../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding</a> &amp;, <a href="../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *);</span>
<a id="line63"></a><span class="lineno">63</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolFactory.html#Language" title="enum Synopsis::SymbolFactory::Language">Language</a>                      <a href="../../Scopes/Synopsis/SymbolFactory.html#my_language" title="data member Synopsis::SymbolFactory::my_language">my_language</a>;</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolFactory.html#Scopes" title="typedef Synopsis::SymbolFactory::Scopes">Scopes</a>                        <a href="../../Scopes/Synopsis/SymbolFactory.html#my_scopes" title="data member Synopsis::SymbolFactory::my_scopes">my_scopes</a>;</span>
<a id="line66"></a><span class="lineno">66</span><span class="line">  <span class="comment">//. When parsing a function definition the declarator is seen first,</span></span>
<a id="line67"></a><span class="lineno">67</span><span class="line"><span class="comment">  //. and thus a prototype is created to hold the parameters.</span></span>
<a id="line68"></a><span class="lineno">68</span><span class="line"><span class="comment">  //. Later, when the function definition proper is seen, the symbols</span></span>
<a id="line69"></a><span class="lineno">69</span><span class="line"><span class="comment">  //. are transfered and the prototype is deleted.</span></span>
<a id="line70"></a><span class="lineno">70</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html" title="class Synopsis::SymbolLookup::PrototypeScope">SymbolLookup::PrototypeScope</a> *<a href="../../Scopes/Synopsis/SymbolFactory.html#my_prototype" title="data member Synopsis::SymbolFactory::my_prototype">my_prototype</a>;</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">  <span class="comment">//. When parsing a class or function template the template-parameter-list</span></span>
<a id="line72"></a><span class="lineno">72</span><span class="line"><span class="comment">  //. is seen first. Since ClassSpec and Declarator don't know they are part</span></span>
<a id="line73"></a><span class="lineno">73</span><span class="line"><span class="comment">  //. of a template declaration, we cache it here so it gets consumed when</span></span>
<a id="line74"></a><span class="lineno">74</span><span class="line"><span class="comment">  //. the Class or PrototypeScope are created.</span></span>
<a id="line75"></a><span class="lineno">75</span><span class="line"><span class="comment">  // FIXME: Should ClassSpec get a flag so it knows it's a template, similar</span></span>
<a id="line76"></a><span class="lineno">76</span><span class="line"><span class="comment">  //        to Encodings helt in Declarators ?</span></span>
<a id="line77"></a><span class="lineno">77</span><span class="line">  <a href="../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">SymbolLookup::TemplateParameterScope</a> *<a href="../../Scopes/Synopsis/SymbolFactory.html#my_template_parameters" title="data member Synopsis::SymbolFactory::my_template_parameters">my_template_parameters</a>;</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">};</span>
<a id="line79"></a><span class="lineno">79</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">}</span>
<a id="line81"></a><span class="lineno">81</span>
<a id="line82"></a><span class="lineno">82</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
